# SPDX-FileCopyrightText: 2020 UMG MeDIC <marcel.parciak@med.uni-goettingen.de>
#
# SPDX-License-Identifier: GPL-3.0-or-later

"""Initial table creation.

Revision ID: 2476740d1850
Revises: 
Create Date: 2020-07-20 16:44:15.737196

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '2476740d1850'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('job',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('version', sa.String(), nullable=True),
    sa.Column('path', sa.String(), nullable=True),
    sa.Column('available', sa.Boolean(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_job_id'), 'job', ['id'], unique=False)
    op.create_index(op.f('ix_job_name'), 'job', ['name'], unique=False)
    op.create_index(op.f('ix_job_version'), 'job', ['version'], unique=False)
    op.create_table('job_run',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('job_id', sa.Integer(), nullable=True),
    sa.Column('state', sa.Enum('started', 'completed', 'retrieved', name='jobstate'), nullable=True),
    sa.Column('started_at', sa.DateTime(), nullable=True),
    sa.Column('completed_at', sa.DateTime(), nullable=True),
    sa.Column('retrieved_at', sa.DateTime(), nullable=True),
    sa.Column('response', sa.JSON(), nullable=True),
    sa.ForeignKeyConstraint(['job_id'], ['job.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_job_run_id'), 'job_run', ['id'], unique=False)
    op.create_index(op.f('ix_job_run_job_id'), 'job_run', ['job_id'], unique=False)
    op.create_index(op.f('ix_job_run_state'), 'job_run', ['state'], unique=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_job_run_state'), table_name='job_run')
    op.drop_index(op.f('ix_job_run_job_id'), table_name='job_run')
    op.drop_index(op.f('ix_job_run_id'), table_name='job_run')
    op.drop_table('job_run')
    op.drop_index(op.f('ix_job_version'), table_name='job')
    op.drop_index(op.f('ix_job_name'), table_name='job')
    op.drop_index(op.f('ix_job_id'), table_name='job')
    op.drop_table('job')
    # ### end Alembic commands ###